CON { QS_ButtonScan.spin }
'    { ButtonStart - responsible for the touch pad buttons }
VAR
  Long oneMS
  LONG Buttons
  LONG ButtonCog
  LONG Stack[ 16 ]                 ' define my stack

'OBJ util:"QS_Utilities"

PUB start( ButtonAdr )                  ' start this in a new cog
  oneMs := clkfreq / 1000   
  Buttons := ButtonAdr                  ' save status
  if ButtonCog
    cogstop(ButtonCog-1)                ' no cog available
  ButtonCog := cognew(ButtonScan, @Stack) + 1
  
PUB ButtonScan | B, B1                   ' local variables
  dira [0..7] := %11111111               ' all pad pins outputs    
  outa [0..7] := %11111111               ' all pad pins high   
  'main loop - scan the buttons   
  Repeat                                 ' loop forever
     Repeat B from 0 to 7                ' QS LEDS are pins 0-7
       dira [B] := 1                     ' make pin an output 
       dira [B] := 0                     ' make pin an input
       waitcnt(oneMS * 4 + cnt)
       WaitMS(4)                         ' short delay for some decay
       B1 := ina[B]                      ' read the pad
       if B1 == 0                        ' 0 here means pressed
          BYTE[Buttons] |= |< B          ' set bit if pressed   
       else                    
          BYTE[Buttons] &= !|< B         ' clear bit if not

PUB WaitMS(W)                      'wait for W milliseconds
  WaitCNT ((W*oneMS)+cnt)